/*===================================
		Copyright Yakibomb
*///=================================

/*
	VS_COND_PORTABLE_DISPENSER
	- When the owner is in vicinity of an Amplifier (custom Engineer building), user is given crits.
	- Works on any entity
*/

class VS_COND_PORTABLE_DISPENSER extends VSConds_Base
{
	//We consider this a buff, so it shouldn't be removed upon touching resupply
	removedByResupply = false;	//`false` prevents removal on resupply
	
	function AddCond() {
		
		provider = provider == null ? entity : provider
		
//Creates medic healbeam fluff around patient
//Deletes itself on condition end
		VSCONDS_CreateTeamParticle(condition,provider, entity, entity.GetOrigin(), "medic_radiusheal_red_volume","medic_radiusheal_blue_volume")
	//	VSCONDS_CreateTeamParticle(condition,provider, entity, entity.GetOrigin(), "soldierbuff_red_spikes","soldierbuff_blue_spikes")
	//	VSCONDS_CreateTeamParticle(condition,provider, entity, entity.GetOrigin(), "soldierbuff_red_spirial","soldierbuff_blue_spirial")
	
//Creates team-specific dispenser beam particles, originating from particle_origin
//Deletes itself on condition end
		local particle_origin = entity.GetOrigin() + entity.GetAbsAngles().Up()*90;
		
		VSCONDS_CreateBeamParticle(condition,provider, entity, particle_origin, "dispenser_beam_red_trail", "dispenser_beam_blue_trail")
		VSCONDS_CreateBeamParticle(condition,provider, entity, particle_origin, "medicgun_beam_red_invunglow", "medicgun_beam_blue_invunglow")
		VSCONDS_CreateBeamParticle(condition,provider, entity, particle_origin, "medicgun_beam_attrib_overheal_red", "medicgun_beam_attrib_overheal_blue")


//Creates team-specific model (cute baby dispenser HEH)
		local model_path = "models/buildables/dispenser_light.mdl";
		local model_origin = entity.GetOrigin() + entity.GetAbsAngles().Up()*90;
		
		local model = VSCONDS_CreateTeamProp(condition,provider, entity, model_origin, model_path)
		
		model.SetSkin(entity.GetTeam() == 2 ? 0 : 1);
		model.SetModelScale(0.5, 0)

	//Filter out non-player entities.
		if ( entity.GetClassname() != "player" ) return;
		
		entity.AddCondEx(56, -1, provider.GetOwner())
	}
	

//Note: Particles get cleaned up automatically, so no need to put anything in RemoveCond()
	function RemoveCond() {
		if ( entity.GetClassname() != "player" ) return;
		
		entity.RemoveCond(56)
	}
}
	VSCONDS_ADD_CONDITION("VS_COND_PORTABLE_DISPENSER");