/*===================================
		Copyright Yakibomb
*///=================================

/*
	VS_COND_SHIELD
	- Entity is given a shield
	- Works on all entities.
*/

class VS_COND_SHIELD extends VSConds_Base
{
	//We consider this a buff, so it shouldn't be removed upon touching resupply
	removedByResupply = false;		//`false` prevents removal by resupply
	//addcondIgnoreDeathState = true;	//`true` allows adding condition even when target is considered dead
	
	function AddCond() {
	//Creates shield
		local model = VSCONDS_CreateTeamProp(condition,entity, entity, entity.GetOrigin(), "models/effects/resist_shield/resist_shield.mdl")
		EntFireByHandle(model,"DisableShadow","",0.0,model,model);
	//Fixes up the shield model on non-player entities
		model.SetSkin(entity.GetTeam() == 2 ? 0 : (entity.GetTeam() == 3 ? 1 : 3));
		
	// Calculates shield size.
	//	For players, only calculate using modelscale
		if ( entity.IsPlayer() ) {
			model.SetModelScale(entity.GetModelScale(), 0);
			return;
		}
	//	For non-players, use formula
		local entity_maxs = entity.GetBoundingMaxs();
		local model_maxs = Vector(28.291979, 27.681454, 85.012115);	//resist_shield's default maxs

		local size_entity = entity_maxs.z;
		local size_model = model_maxs.z;
		
		local bigger = size_model > size_entity ? size_model : size_entity;
		local smaller = size_model < size_entity ? size_model : size_entity;
		
		local scale_z;
		if ( entity_maxs.x < model_maxs.x 
		  && entity_maxs.y < model_maxs.y )
			 scale_z = entity.GetModelScale();
		else scale_z = bigger/smaller;
		
	//	printl(entity);
	//	printl("SCALED BY : " + scale_z);
		model.SetModelScale(scale_z, 0);
		
		local entity_origin = entity.GetOrigin();
		local entity_center = entity.GetCenter();
		local move_z = entity_origin.z+(entity_center.z-entity_origin.z-(fabs(size_entity*0.5*scale_z)));
		model.SetOrigin(Vector(entity_origin.x,entity_origin.y,move_z));
	//	printl(move_z);
	}
	
	function RemoveCond() {	}
}

	VSCONDS_ADD_CONDITION("VS_COND_SHIELD");