/*===================================
		Copyright Yakibomb
*///=================================

// Only boots main code as long as think entity doesn't exist
::addvsconds <- Entities.FindByName(null, "vscript_addvscond_bigthink")

// If think ent is found, only run the cleanup function and not the main code.
if ( addvsconds && addvsconds.IsValid() ) return VSCONDS_CLEANUP();

// The following runs first boot OR using function VSCONDS_COMPILE()
printl("AddVSCond Executing");

::worldspawn <- Entities.First();
::ROOT <- getroottable();


IncludeScript("addvscond/code/vsconds_constants.nut");
IncludeScript("addvscond/code/vsconds_settings.nut");
IncludeScript("addvscond/code/compile_steps/vsconds_conditions_compiler.nut", ROOT);
IncludeScript("addvscond/code/compile_steps/vsconds_conditions_base.nut")

::VSCONDS_RESET_PARAMS <- function() {
	// finite life things that need refreshing
	::VSCOND_COND_PROCESS_ORDER <- [];		//Condition lined up to be processed under I/O delay
	::VSCOND_ENTS_UNDER_CONDS <- [null];	//Entities under vsconds
	::VSCOND_HIDDEN_WEARABLES <- {};		//parented wearable to entity; for applying weapon attributes (not implemented) and particle origin fixes
	
	if ( addvsconds ) return;
	
	// stuff that needs to be defined once
	::VSCOND_COND_NAMES <- [];				//Condition string names
	::VSCOND_COND_FUNC <- [];				//Condition functions
	::VSCONDS_CLEANUP_RUNNING <- false;		//Is VSCONDS_CLEANUP() function running?
	::VSCONDS_CLEANUP_RETRIES <- 0;			//Counts the amount of retries before failing (3 by default)
	::VS_COND_BASE <- VSConds_Base;
	VSCONDS_PROCESS_CONDITION("VS_COND_BASE");
	
	//EXAMPLE VSConds
	IncludeScript("addvscond/conditions/example_conditions_list.nut");
	
}
//Executes above function
VSCONDS_RESET_PARAMS()

// Processes rest of code
IncludeScript("addvscond/code/vsconds_util.nut", ROOT);
IncludeScript("addvscond/code/vsconds_main.nut", ROOT);
IncludeScript("addvscond/code/vsconds_cleanup.nut", ROOT);

// Parse functions starting with CBaseEntity_
EntFireByHandle(worldspawn,"RunScriptCode","IncludeScript(\"addvscond/code/compile_steps/vsconds_parse_cbaseentity.nut\")",0.0,worldspawn,worldspawn);


// Deletes any entities named vscript_addvscond
while ( addvsconds = Entities.FindByName(null, "vscript_addvscond_bigthink") ) addvsconds.Kill();

// Creates the thinking entity
// It is meant to be a fixture on the map
// classname "move_rope" prevents this entity from disappearing on map resets
addvsconds = SpawnEntityFromTable("move_rope", {
	targetname	= "vscript_addvscond_bigthink",
	vscripts	= "addvscond/code/vsconds_think",
	thinkfunction	= "VSConds_Think",
});


// Recompile function
::VSCONDS_COMPILE <- function() {
	if ( addvsconds && addvsconds.IsValid() ) VSCONDS_CLEANUP();
	
	while ( addvsconds = Entities.FindByName(null, "vscript_addvscond_bigthink") ) addvsconds.Kill();
	
	if ( !addvsconds )
		IncludeScript("addvscond/init.nut");
}